#coding:utf-8
import RPi.GPIO as GPIO ##引入GPIO模块
import time    ##引入time库
GPIO.setwarnings(False) 

'''
from JiuJiang
树莓酱的操作实例
https:://www.shumeijiang.com

-- motor动作类封装
-- 2021-05-01
'''

#定义四个引脚
IN1Pin = 18
IN2Pin = 19
IN3Pin = 20
IN4Pin = 21

#设置为BCM编码 同时四个引脚为输出模式
GPIO.setmode(GPIO.BCM)
GPIO.setup(IN1Pin, GPIO.OUT)
GPIO.setup(IN2Pin, GPIO.OUT)
GPIO.setup(IN3Pin, GPIO.OUT)
GPIO.setup(IN4Pin, GPIO.OUT)

class motorAct:

    def __init__(self):
        #初始化四个引脚
        self.setVal(GPIO.LOW, GPIO.LOW, GPIO.LOW, GPIO.LOW)

        #定义初始化
    def setVal(self, val1, val2, val3, val4):
        GPIO.output(IN1Pin, val1)
        GPIO.output(IN2Pin, val2)
        GPIO.output(IN3Pin, val3)
        GPIO.output(IN4Pin, val4)

        #定义一步需要的操作
    def oneStep(self, dely):
        if not dely:
            dely = 0.005
        self.setVal(GPIO.HIGH, GPIO.LOW, GPIO.LOW, GPIO.LOW)
        time.sleep(dely)
        self.setVal(GPIO.LOW, GPIO.HIGH, GPIO.LOW, GPIO.LOW)
        time.sleep(dely)
        self.setVal(GPIO.LOW, GPIO.LOW, GPIO.HIGH, GPIO.LOW)
        time.sleep(dely)
        self.setVal(GPIO.LOW, GPIO.LOW, GPIO.LOW, GPIO.HIGH)
        time.sleep(dely)

    #定义一步（反向）需要的操作
    def oneStepBack(self, dely):
        if not dely:
            dely = 0.005
        self.setVal(GPIO.LOW, GPIO.LOW, GPIO.LOW, GPIO.HIGH)
        time.sleep(dely)
        self.setVal(GPIO.LOW, GPIO.LOW, GPIO.HIGH, GPIO.LOW)
        time.sleep(dely)
        self.setVal(GPIO.LOW, GPIO.HIGH, GPIO.LOW, GPIO.LOW)
        time.sleep(dely)
        self.setVal(GPIO.HIGH, GPIO.LOW, GPIO.LOW, GPIO.LOW)
        time.sleep(dely)

    #定义停止运动
    def stopMoving(self):
        self.setVal(GPIO.LOW, GPIO.LOW, GPIO.LOW, GPIO.LOW)

